import { EntityInventoryComponent, ItemStack, system, world, } from "@minecraft/server";
export class plane_Manager {
    static drop(plane) {
        const item = new ItemStack("eddsplanes:plane_spawn_egg", 1);
        world.getDimension(plane.dimension.id).spawnItem(item, plane.location);
        for (let i = 0; i <= 4; i++) {
            const inv = plane.getComponent(EntityInventoryComponent.componentId);
            if (inv.container.getSlot(i).getItem() != undefined) {
                const item = inv.container.getSlot(i).getItem();
                world.getDimension(plane.dimension.id).spawnItem(item, plane.location);
            }
        }
        plane.remove();
    }
    static setOwner(plane, id) {
        plane.setDynamicProperty("ownerID", id);
    }
    static getOwner(plane) {
        const ID = plane.getDynamicProperty("ownerID");
        return ID;
    }
}
function fly(plane, player) {
    if (plane.location.y <= 340) {
        plane.runCommand("execute positioned ^^^1 run tag @p[r=5] add controlling");
        if (player.hasTag("controlling")) {
            if (plane.isOnGround == false) {
                const hp = plane.getComponent("minecraft:health");
                plane.clearVelocity();
                const face_Location = player.getViewDirection(); // {x:x1,y:y1,z:z1}
                const x_Facing = face_Location.x * 25;
                const y_Facing = face_Location.y * 3;
                const z_Facing = face_Location.z * 25;
                const entity_Location = player.getHeadLocation();
                const location = {
                    x: entity_Location.x + x_Facing,
                    y: entity_Location.y + y_Facing,
                    z: entity_Location.z + z_Facing,
                };
                const face_Location2 = plane.getViewDirection(); // {x:x1,y:y1,z:z1}
                const x_Facing2 = face_Location2.x * -4;
                const y_Facing2 = face_Location2.y * -4;
                const z_Facing2 = face_Location2.z * -4;
                const entity_Location2 = plane.getHeadLocation();
                const location2 = {
                    x: entity_Location2.x + x_Facing2,
                    y: entity_Location2.y - 0.5,
                    z: entity_Location2.z + z_Facing2,
                };
                if (hp.currentValue <= hp.effectiveMax / 3) {
                    //doing the particle command cus in scripting you can't spawn particles higher than the height limit
                    world
                        .getDimension(plane.dimension.id)
                        .runCommand("particle minecraft:mobflame_single " + location2.x + " " + location2.y + " " + location2.z);
                }
                //doing the particle command cus in scripting you can't spawn particles higher than the height limit
                world
                    .getDimension(plane.dimension.id)
                    .runCommand("particle minecraft:cauldron_explosion_emitter " + location2.x + " " + location2.y + " " + location2.z);
                world.playSound("mob.horse.breathe", location2, { volume: 0.6, pitch: 0.5 });
                plane.applyKnockback(location.x - entity_Location.x, location.z - entity_Location.z, 1.3, (location.y - entity_Location.y) * 0.1);
                plane.setRotation({ x: 0, y: player.getRotation().y });
                plane.triggerEvent("to_air");
                system.runTimeout(() => {
                    if (plane.isValid()) {
                        if (player.isValid()) {
                            const riding = player.getComponent("minecraft:riding");
                            if (riding != undefined) {
                                if (riding.entityRidingOn.id != plane.id) {
                                    plane.triggerEvent("to_ground");
                                }
                            }
                            else {
                                plane.triggerEvent("to_ground");
                            }
                        }
                        else {
                            plane.triggerEvent("to_ground");
                        }
                    }
                }, 5);
                player.removeTag("controlling");
            }
        }
    }
    else {
        plane.triggerEvent("to_ground");
    }
}
system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        const riding = player.getComponent("minecraft:riding");
        if (riding?.entityRidingOn?.typeId == "eddsplanes:plane") {
            const plane = riding.entityRidingOn;
            const owner = plane_Manager.getOwner(plane);
            if (owner == undefined) {
                plane_Manager.setOwner(plane, player.id);
            }
            const inv = plane.getComponent(EntityInventoryComponent.componentId);
            if (inv?.container?.getItem(0)?.typeId == "minecraft:coal" ||
                inv?.container?.getItem(0)?.typeId == "minecraft:charcoal") {
                fly(plane, player);
            }
            else if (inv?.container?.getItem(1)?.typeId == "minecraft:coal" ||
                inv?.container?.getItem(1)?.typeId == "minecraft:charcoal") {
                fly(plane, player);
            }
            else if (inv?.container?.getItem(2)?.typeId == "minecraft:coal" ||
                inv?.container?.getItem(2)?.typeId == "minecraft:charcoal") {
                fly(plane, player);
            }
            else if (inv?.container?.getItem(3)?.typeId == "minecraft:coal" ||
                inv?.container?.getItem(3)?.typeId == "minecraft:charcoal") {
                fly(plane, player);
            }
            else if (inv?.container?.getItem(4)?.typeId == "minecraft:coal" ||
                inv?.container?.getItem(4)?.typeId == "minecraft:charcoal") {
                fly(plane, player);
            }
            else {
                plane.triggerEvent("to_ground");
            }
        }
    }
}, 5);
function removeItem(inv, plane, slot) {
    const item = inv.container.getItem(slot);
    let amount = item.amount - 1;
    if (amount == 0) {
        inv.container.setItem(slot, undefined);
        world.playSound("fire.ignite", plane.location, { pitch: 1 });
        world.playSound("fire.fire", plane.location, { pitch: 4 });
        world.playSound("fire.fire", plane.location, { pitch: 4 });
    }
    else {
        item.amount = item.amount - 1;
        inv.container.setItem(slot, item);
        world.playSound("fire.fire", plane.location, { pitch: 1 });
        world.playSound("fire.fire", plane.location, { pitch: 1 });
    }
}
system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        const riding = player.getComponent("minecraft:riding");
        if (riding?.entityRidingOn?.typeId == "eddsplanes:plane") {
            const plane = riding.entityRidingOn;
            const inv = plane.getComponent(EntityInventoryComponent.componentId);
            if (plane.isOnGround == false) {
                plane.runCommand("execute positioned ^^^1 run tag @p[r=5] add controlling");
                if (player.hasTag("controlling")) {
                    let took_out = false;
                    let tookTNT = false;
                    for (let i = 4; i >= 0; i--) {
                        if ((inv?.container?.getItem(i)?.typeId == "minecraft:coal" ||
                            inv?.container?.getItem(i)?.typeId == "minecraft:charcoal") &&
                            took_out == false) {
                            took_out = true;
                            removeItem(inv, plane, i);
                        }
                    }
                    player.removeTag("controlling");
                }
            }
        }
    }
}, 100);
system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        const riding = player.getComponent("minecraft:riding");
        if (riding?.entityRidingOn?.typeId == "eddsplanes:plane") {
            const plane = riding.entityRidingOn;
            const inv = plane.getComponent(EntityInventoryComponent.componentId);
            if (plane.isOnGround == false) {
                plane.runCommand("execute positioned ^^^1 run tag @p[r=5] add controlling");
                if (player.hasTag("controlling")) {
                    let took_out = false;
                    let tookTNT = false;
                    for (let i = 4; i >= 0; i--) {
                        if ((inv?.container?.getItem(i)?.typeId == "minecraft:coal" ||
                            inv?.container?.getItem(i)?.typeId == "minecraft:charcoal") &&
                            took_out == false) {
                            took_out = true;
                            for (let i = 4; i >= 0; i--) {
                                if (inv?.container?.getItem(i)?.typeId == "minecraft:tnt" && tookTNT == false) {
                                    tookTNT = true;
                                    removeItem(inv, plane, i);
                                    world.playSound("random.fuse", plane.location);
                                    world.getDimension(plane.dimension.id).spawnEntity("minecraft:tnt", plane.location);
                                }
                            }
                        }
                    }
                    player.removeTag("controlling");
                }
            }
        }
    }
}, 200);
world.beforeEvents.playerInteractWithEntity.subscribe((data) => {
    const player = data.player;
    const plane = data.target;
    if (plane.typeId == "eddsplanes:plane") {
        if (player.isSneaking) {
            const ownerID = plane_Manager.getOwner(plane);
            if (ownerID != undefined) {
                if (ownerID == player.id) {
                    data.cancel = true;
                    system.runTimeout(() => {
                        plane_Manager.drop(plane);
                    });
                }
            }
        }
    }
});
world.beforeEvents.playerInteractWithBlock.subscribe((data) => {
    if (data.block.permutation.type.id == "minecraft:mob_spawner") {
        if (data.itemStack?.typeId == "eddsplanes:plane_spawn_egg") {
            data.cancel = true;
        }
    }
});
